quill 0.1.2+1

  • README.md
  • CHANGELOG.md
  • Example
  • Installing
  • Versions
  • new50

Quill

A lightweight game engine, that keeps your game simple by only using feathers and quills!

Why Quill?

The idea of Quill is to give you full control over your game or application.
Using Quill is simple, everything is a node based Feather, but your Feathers can turn into a Quill, which contains many of the Component class. Quills can be preset to contain specific components. You can use preset Quills, or you can create your own!

Quick Start

lib/main.dart

import 'package:quill/quill.dart';
import 'dart:ui'

void main() async {
  /// Start the application with 60.0 frames per second
  new QuillEngine(new Application(), fps: 60.0)
    ..start();
}

class Application extends Feather {
  /// `Sprite` is a `Quill` preset
  Sprite user;
  @override
  void init() {
    super.init();
    /// Create a Sprite
    user = new Sprite()
      ..initWithColor(const Color(0xFFFF0000)
      ..setPosition(0.0, 0.0)
      ..setSize(100.0, 100.0);
    addFeather('user', user);

    addFeather<Sprite>('block', new Sprite())
      ..initWithColor(const Color(0xFF0000FF))
      ..setPosition(200.0, 200.0
      ..setSize(50.0, 50.0)
      ..origin = Origin.top_left;
  }

  @override
  void update(Time time) {
    super.update(time);
    /// Move the user 10 pixels per second
    user.position.x += 10.0 * time.elapsedSeconds;
  }
}

The Feather Loop

Each feather, and all associated components follow a main way of looping. Primarily through the input, update, and render methods.

init: Initializes the feather/component.

destroy: Disposes of the feather/component, and all internal properties.

load: Loads any data neccessary for the feather/component.

unload: Unloads any data, to make room for loading new data.

input: Handles input events as neccessary for the feather/component.

update: Updates our feather/component.

render: Draws our feather/component to the screen.

Custom Components & Quills

Creating custom components & quills is simple, you just need to extend the Quill or Component class. Use the Feather Loop above to override any methods you need, or create your own unique methods. Try to be consistent, and avoid using constructors, as there are plans to remove the use of them as soon as possible. So, rather than passing parameters in the constructor, use a custom setter such as setSize(double width, double height); like the SizeComponent. For Quills, using custom initializers works great, like the Sprite quill: initWithColor(Color color, Point position, Size size)... then you can initialize each of these as components!

Upcoming

Please note that Quill is still in it's early stages, so there are a lot of missing features. I have finally gotten the foundation finalized, so now it's just a matter of adding each of these features. Here is a list of upcoming features:

Version 0.2.0

  • Audio
  • Image Caching
  • LifeCycle Management

Version 0.x.0

  • Local/Push Notifications
  • Admob support (?) - May be in a separate package such as quill-admob
  • Native Game Center support

Suggestions & Feedback

I hope this library helps others build their games rapidly an easily. Any feedback that could help make Quill even better, are more than welcome! Please use github as an open way to communicate those ideas.

Contributing

I hope that one day there will be a community of components and quills to help new users streamline their app development.

More Coming soon...

0.0.1

  • TODO: Describe initial release.

example/README.md

quill_example

Demonstrates how to use the quill plugin.

Getting Started

For help getting started with Flutter, view our online documentation.

Use this package as a library

1. Depend on it

Add this to your package's pubspec.yaml file:


dependencies:
  quill: ^0.1.2+1

2. Install it

You can install packages from the command line:

with Flutter:


$ flutter packages get

Alternatively, your editor might support flutter packages get. Check the docs for your editor to learn more.

3. Import it

Now in your Dart code, you can use:


import 'package:quill/quill.dart';
  
Version Uploaded Documentation Archive
0.1.2+1 Nov 5, 2018 Go to the documentation of quill 0.1.2+1 Download quill 0.1.2+1 archive
0.1.1+2 Nov 5, 2018 Go to the documentation of quill 0.1.1+2 Download quill 0.1.1+2 archive
0.1.1+1 Nov 5, 2018 Go to the documentation of quill 0.1.1+1 Download quill 0.1.1+1 archive
0.1.1 Oct 28, 2018 Go to the documentation of quill 0.1.1 Download quill 0.1.1 archive
0.1.0 Oct 27, 2018 Go to the documentation of quill 0.1.0 Download quill 0.1.0 archive
Popularity:
Describes how popular the package is relative to other packages. [more]
0
Health:
Code health derived from static analysis. [more]
100
Maintenance:
Reflects how tidy and up-to-date the package is. [more]
100
Overall:
Weighted score of the above. [more]
50
Learn more about scoring.

We analyzed this package on Nov 14, 2018, and provided a score, details, and suggestions below. Analysis was completed with status completed using:

  • Dart: 2.0.0
  • pana: 0.12.6
  • Flutter: 0.11.3

Platforms

Detected platforms: Flutter

References Flutter, and has no conflicting libraries.

Dependencies

Package Constraint Resolved Available
Direct dependencies
Dart SDK >=2.0.0-dev.68.0 <3.0.0
flutter 0.0.0
Transitive dependencies
collection 1.14.11
meta 1.1.6
sky_engine 0.0.99
typed_data 1.1.6
vector_math 2.0.8
Dev dependencies
flutter_test